<Query Kind="Program">
  <Namespace>System.Threading.Tasks</Namespace>
</Query>

void Main()
{
	var channel = new FastChannel ("test");
	Proxy<RemoteClass> remoteProxy = channel.Activate<RemoteClass>();
	remoteProxy.Run (remote => remote.SomeRemoteMethod (123, "hello, world"));
}

class FastChannel
{
	readonly OutPipe _outPipe;
	readonly InPipe _inPipe;
	
	public FastChannel (string name)
	{		
	}

	public Proxy<TRemote> Activate<TRemote>() where TRemote : class
	{
		var proxy = new Proxy<TRemote> (this);
		// Serialize class instantiation and send to _outPipe
		// ....
		return proxy;
	}
}

class RemoteClass
{
	public void SomeRemoteMethod (int x, string s) 
	{
		/*............*/
	}
}

class Proxy<TRemote>
{
	FastChannel _channel;
	public Proxy (FastChannel channel) => _channel = channel;
	
	public void Run (Expression<Action<TRemote>> a)
	{
		if (a.Body.NodeType != ExpressionType.Call)
			throw new NotSupportedException ($"Expressions of type {a.Body.NodeType} are not supported");

		var mce = (MethodCallExpression)a.Body;
		mce.Method.Dump ("Running this remote method");
		mce.Arguments.Dump ("with these arguments");
		
		// byte[] payload = SerializeMethodCall (mce);
		// _channel.Send (payload);
	}

	#region Eval
	
	public TResult Eval<TResult> (Expression<Func<TRemote, TResult>> func)
		=> throw new NotImplementedException();

	#endregion
	#region Async

	public Task<TResult> Eval<TResult> (Expression<Func<TRemote, Task<TResult>>> func)
		=> throw new NotImplementedException();
	
	#endregion
}

class InPipe { }
class OutPipe { }